/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.common.security.utils.SecurityUtils
 *  com.ruoyi.system.controller.SysPostController
 *  com.ruoyi.system.domain.SysPost
 *  com.ruoyi.system.service.ISysPostService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.validation.annotation.Validated
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.domain.SysPost;
import com.ruoyi.system.service.ISysPostService;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/post"})
public class SysPostController
extends BaseController {
    @Autowired
    private ISysPostService postService;

    @RequiresPermissions(value={"system:post:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(SysPost post) {
        this.startPage();
        List list = this.postService.selectPostList(post);
        return this.getDataTable(list);
    }

    @Log(title="岗位管理", businessType=BusinessType.EXPORT)
    @RequiresPermissions(value={"system:post:export"})
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, SysPost post) {
        List list = this.postService.selectPostList(post);
        ExcelUtil util = new ExcelUtil(SysPost.class);
        util.exportExcel(response, list, "岗位数据");
    }

    @RequiresPermissions(value={"system:post:query"})
    @GetMapping(value={"/{postId}"})
    public AjaxResult getInfo(@PathVariable Long postId) {
        return this.success((Object)this.postService.selectPostById(postId));
    }

    @RequiresPermissions(value={"system:post:add"})
    @Log(title="岗位管理", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysPost post) {
        if (!this.postService.checkPostNameUnique(post)) {
            return this.error("新增岗位'" + post.getPostName() + "'失败，岗位名称已存在");
        }
        if (!this.postService.checkPostCodeUnique(post)) {
            return this.error("新增岗位'" + post.getPostName() + "'失败，岗位编码已存在");
        }
        post.setCreateBy(SecurityUtils.getUsername());
        return this.toAjax(this.postService.insertPost(post));
    }

    @RequiresPermissions(value={"system:post:edit"})
    @Log(title="岗位管理", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysPost post) {
        if (!this.postService.checkPostNameUnique(post)) {
            return this.error("修改岗位'" + post.getPostName() + "'失败，岗位名称已存在");
        }
        if (!this.postService.checkPostCodeUnique(post)) {
            return this.error("修改岗位'" + post.getPostName() + "'失败，岗位编码已存在");
        }
        post.setUpdateBy(SecurityUtils.getUsername());
        return this.toAjax(this.postService.updatePost(post));
    }

    @RequiresPermissions(value={"system:post:remove"})
    @Log(title="岗位管理", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{postIds}"})
    public AjaxResult remove(@PathVariable Long[] postIds) {
        return this.toAjax(this.postService.deletePostByIds(postIds));
    }

    @GetMapping(value={"/optionselect"})
    public AjaxResult optionselect() {
        List posts = this.postService.selectPostAll();
        return this.success((Object)posts);
    }
}

